# > *** MoReFEM copyright notice *** #
#######################################################################################################################
# This file is part of the [MoReFEM](https://gitlab.inria.fr/MoReFEM/CoreLibrary/MoReFEM) library.
# It is released under the LGPL v3 license; a copy is provided in the LICENSE file shipped with it.
#
# MoReFEM is mostly developed by [M3DISIM team-project](https://www.inria.fr/m3disim).
# You may contact its developers by writing at morefem-maint@inria.fr.
#######################################################################################################################
# *** MoReFEM copyright notice *** < #

import os
import sys
import argparse
import tempfile

from clean_up_iwyu_suggestions import CleanUpIWYUSuggestion


class ParseLog():


    def __init__(self, log):

        with open(log) as FILE_in:

            for line in FILE_in:
                if line.startswith("The full include-list for"):
                    self.__CleanUpIWYUForOneFile(line, FILE_in)
                    print("\n")

    def __CleanUpIWYUForOneFile(self, first_line, file_in):
        
        with tempfile.NamedTemporaryFile(mode='w+t', delete = False) as temp_file:
        
            line = ""

            temp_file.write(f"{first_line}")

            while line != "---":
                line = file_in.readline()
                line = line.strip()
                temp_file.write(f"{line}\n")

            temp_file.close()
            
            output_for_one_file = CleanUpIWYUSuggestion(temp_file.name)
            output_for_one_file.Print()            


class ParseCLI():
    """Just a facility to call IWYUfrom command line.
    
    return The error code to be transmitted to sys.exit().
    """
    
    def __init__(self, args):
        parser = argparse.ArgumentParser(
            description='The full log generated by IWYU', \
            formatter_class=argparse.RawDescriptionHelpFormatter)
            
        parser.add_argument(
            '--log',
            required=True,
            help= 'File which contents the IWYU suggestion.'
        )
        
        parsed_args = parser.parse_args(args)
        
        ParseLog(parsed_args.log)



if __name__ == "__main__":
    ParseCLI(sys.argv[1:])

